//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  Konfiguration                                                                       //
//                                                    ________________________________  //
//                                                    Copyright  2010  Reimar Grasbon  //
//                                                    All rights reserved               //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////
//                                                                                      //
//  This software is subjected to the FreeBSD License. Redistribution and use in source //
//  and binary forms, with or without modification, are permitted provided that the     //
//  following conditions are met:                                                       //
//                                                                                      //
//  1. Redistributions of source code must retain the above copyright notice, this list //
//     of conditions and the following disclaimer.                                      //
//                                                                                      //
//  2. Redistributions in binary form must reproduce the above copyright notice, this   //
//     list of conditions and the following disclaimer in the documentation and/or      //
//     other materials provided with the distribution.                                  //
//                                                                                      //
//  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY //
//  EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED           //
//  WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.  //
//  IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,    //
//  INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT  //
//  NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR  //
//  PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,   //
//  WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)  //
//  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE          //
//  POSSIBILITY OF SUCH DAMAGE.                                                         //
//                                                                                      //
//////////////////////////////////////////////////////////////////////////////////////////

#pragma once

///////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Typenschild  //////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define DEV_APPL_TYPE               00001       // Anwendungstypennummer:              00001 ..  00099 [#]
#define DEV_APPL_VERS                  21       // Anwendungsversion (Major.Minor):       01 ..     99 [#]
#define DEV_BOARD_TYPE              00023       // Boardtypennummer:                   00001 ..  99999 [#]
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define GENADR_A(T) (100 + (10 ## T))           // GENADR_XX erzeugt aus den beiden letzten Stellen der
#define GENADR_B(X) GENADR_A(X%100)             // Boardtypennummer in <DEV_BOARD_TYPE> die werksvoreinge-
#define GENADR_XX   GENADR_B(DEV_BOARD_TYPE)    // stellte Gerteadresse gem Cy4NET-Konvention: 100 + xx

///////////////////////////////////////////////////////////////////////////////////////////////////////////
//  Konfiguration  ////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////////
#define CFG_PGMLDR_SIZE                      4  // Gre des Programmladers                    1/2/4      [KiB]
#define CFG_EEP_CY4_ADDRESS_PARTITION        2  // EEProm-Start der Cy4-Adress-Partition:     0 ..  1023  [#]
#define CFG_DEFAULT_CY4_ADDRESS_NET        255  // Voreingestellte-Cy4-Netzadresse:           1 ..   255  [#]
#define CFG_DEFAULT_CY4_ADDRESS_DEV  GENADR_XX  // Voreingestellte-Cy4-Gerteadresse:         1 ..   254  [#]
#define CFG_PGMLDR_MARKER               0xD278  // Programmlader-Startmarkierungsmuster:      0 .. 0xFFFF [#]
#define CFG_BUS_INTERBYTE_TIMEOUT            3  // Zeitberschreit. bei Bus-Bytebertr.:      1 ..     30 [ms]
#define CFG_BUS_RX_QUEUE_CAPACITY          210  // Kapazitt der Bus-Empfangsschlange:        1 ..    250 [Byte]
#define CFG_DEAD_PEER_TIMEOUT             3000  // Zeitgrenze bei Ausbleiben von PDUs:     1000 ..   3000 [ms]
#define CFG_SERIAL_RX_QUEUE_CAPACITY       180  // Kapazitt der seriellen Empfangsschlange:  1 ..    250 [Byte]
#define CFG_SERIAL_LINE_CAPACITY           144  // Kapazitt einer seriellen Textzeile:     144 ..    250 [Zeichen]
#define CFG_SERIAL_INTERBYTE_TIMEOUT        50  // Zeitberschreit. bei ser. Bytebertr.:     1 ..   1000 [ms]
#define CFG_SERIAL_NEWLINE               "\r\n" // Zeichensequenz fr Zeilenwechsel:          Zeichenkette
#define CFG_SYSTEM_LED                     B,4  // Port,Pin der Systemzustandsleuchte
#define CFG_LED_LOW_ACTIVE               false  // Systemzustandsleuchte ist Low-Active
///////////////////////////////////////////////////////////////////////////////////////////////////////////
